var uri;
var prevUri;
var httpReq;
var textDoc;
var status;

// Initialize widget
function init() {
	if (window.widget) {
		widget.onshow = onShow;
	}

	httpReq = new XMLHttpRequest();
	httpReq.onreadystatechange = processReqChange;

	reload();
}

function onShow() {
	uri = getURI();
	if (uri != prevUri)
		getHTML();
}

function getURI() {
	var result;

	if (window.widget) {
		if (AScript)
			result = AScript.askSafari();
		else
			return('Widget plugin not loaded.');
	}
	return(result);
}

function getHTML() {
	httpReq.open('GET', uri, true);
	httpReq.send(null);
}

function reload() {
	uri = getURI();
	getHTML();
}

function processReqChange() {
	if (httpReq.readyState == 4) { // readyState 4 = "complete"
		if (httpReq.status == 200) {
			status = 'HTTP Status: ' + httpReq.status + ' ' + 
				'Content-Type: ' + httpReq.getResponseHeader('Content-Type');
				prevUri = uri;
			textDoc = httpReq.responseText;
		} else {
			status = 'Failed: ' + httpReq.status;
			textDoc = '';
		}
	}

	document.getElementById('uri').innerText = uri;
	document.getElementById('status').innerText = status;
	document.getElementById('source').innerText = textDoc;
}
